#include "klient.h"

Klient::Klient(QWidget *parent): QWidget(parent)
{
//Gniazdo do poczenia
    tcpSocket = new QTcpSocket(this);
    connect(tcpSocket, SIGNAL(readyRead()), this, SLOT(odczytajCzas()));
    connect(tcpSocket, SIGNAL(connected()), this, SLOT(polaczonoZSerwerem()));
    connect(tcpSocket, SIGNAL(disconnected()), this, SLOT(zakonczonoPolaczenie()));
    connect(tcpSocket, SIGNAL(error(QAbstractSocket::SocketError)), this, SLOT(wyswietlBlad(QAbstractSocket::SocketError)));
    // find out which IP to connect to
    QString ipAddress;
    QList<QHostAddress> ipAddressesList = QNetworkInterface::allAddresses();
    // use the first non-localhost IPv4 address
    for (int i = 0; i < ipAddressesList.size(); ++i) {
        if (ipAddressesList.at(i) != QHostAddress::LocalHost &&
            ipAddressesList.at(i).toIPv4Address()) {
            ipAddress = ipAddressesList.at(i).toString();
            break;
        }
    }
    // if we did not find one, use IPv4 localhost
    if (ipAddress.isEmpty())
        ipAddress = QHostAddress(QHostAddress::LocalHost).toString();
    infText = new QTextBrowser();
    infText->setReadOnly(true);
    infText->setFocusPolicy(Qt::NoFocus);
    czasEdit = new QTimeEdit();
    ipEdit = new QLineEdit(ipAddress);
    ipEdit->setMaximumWidth(100);
    portSpin = new QSpinBox();
    portSpin->setRange(1,65535);
    portSpin->setValue(4466);
    czasLabel = new QLabel("Godzina:");
    ipLabel = new QLabel("Ip Serwera:");
    portLabel = new QLabel("Port Serwera:");
    Frame=new QFrame();
    Frame->setFrameShape(QFrame::VLine);
    resetCzasButton = new QPushButton("Resetuj \nCzas");
    connect(resetCzasButton, SIGNAL(clicked()), this, SLOT(resetujCzas()));
    polaczButton = new QPushButton("Pocz z\nSerwerem");
    connect(polaczButton, SIGNAL(clicked()), this, SLOT(rozpocznijPolaczenie()));
    rozlaczButton = new QPushButton("Rozcz z\nSerwerem");
    connect(rozlaczButton, SIGNAL(clicked()), this, SLOT(zakonczPolaczenie()));
    czyscButton = new QPushButton("Wyczy\nOkno");
    connect(czyscButton, SIGNAL(clicked()), this, SLOT(czysc()));
    czyscButton->setMaximumWidth(90);
    zamknijButton = new QPushButton("Zakocz\nDziaanie\nProgramu");
    connect(zamknijButton, SIGNAL(clicked()), this, SLOT(koniec()));
    zamknijButton->setMaximumWidth(90);

    mainLayout = new QGridLayout(this);
    mainLayout->addWidget(infText, 0, 6, 7, 1);
    mainLayout->addWidget(ipLabel,0,0,1,1,Qt::AlignRight);
    mainLayout->addWidget(ipEdit,0,1,1,1,Qt::AlignLeft);
    mainLayout->addWidget(portLabel,1,0,1,1,Qt::AlignRight);
    mainLayout->addWidget(portSpin,1,1,1,1,Qt::AlignLeft);
    mainLayout->addWidget(czasLabel,3,0,1,1,Qt::AlignRight);
    mainLayout->addWidget(czasEdit,3,1,1,1,Qt::AlignLeft);
    mainLayout->addWidget(Frame,0,2,7,1);//Linia dzielca
    mainLayout->addWidget(polaczButton,0,3,1,1,Qt::AlignCenter);
    mainLayout->addWidget(rozlaczButton,1,3,1,1,Qt::AlignCenter);
    mainLayout->addWidget(czyscButton,3,3,1,1,Qt::AlignCenter);
    mainLayout->addWidget(zamknijButton,4,3,1,1,Qt::AlignCenter);
    uplywTimer=new QTimer(this);
    uplywTimer->setSingleShot(false);
    connect(uplywTimer,SIGNAL(timeout()),this,SLOT(uplywCzasu()));
    uplywTimer->start(1000);
    rozlaczButton->setEnabled(false);
    emit resetujCzas();
    Idk=0;
}

Klient::~Klient()
{

}

void Klient::wyslijCzas()
{
    if (Idk!=0)
        infText->append(czasEdit->time().toString("HH:mm:ss")+" - Wysano godzin " );
    QByteArray data;
    QDataStream out(&data, QIODevice::WriteOnly);
    out.setVersion(QDataStream::Qt_4_6);
    if (Idk==0)
        out << (quint16) 0;
    out <<  Idk;//0-poczatek; 1-do synchronizacji
    out << czasEdit->time();
    out.device()->seek(0);
    out << (quint16) (data.size() - sizeof(quint16));
    tcpSocket->write(data);
}

void Klient::odczytajCzas()
{
    QDataStream in(tcpSocket);
    in.setVersion(QDataStream::Qt_4_6);
    if (blockSize == 0){
        if (tcpSocket->bytesAvailable() < (int)sizeof(quint16)){
                        return;
        }
        in >> blockSize;
    }//*/
    if (tcpSocket->bytesAvailable() < blockSize){
        return;
    }
    in >> Idk;
    QTime time;
    in >> time;
    blockSize = 0;
    if(Idk==5){
        infText->append(czasEdit->time().toString("HH:mm:ss")+" - Odebrano danie wysania godziny" );
        Idk=1;
        emit wyslijCzas();//Do synchroniazcji
    }
    else if(Idk==6){
        infText->append("-+-+-+-+-+-+-+-+-+-+-+-+-+-+");
        infText->append(czasEdit->time().toString("HH:mm:ss")+" - Odebrano godzin synchronizacji: "+time.toString("HH:mm:ss"));
        infText->append("-+-+-+-+-+-+-+-+-+-+-+-+");
        czasEdit->setTime(time);
    }
    else if(Idk==7){
        emit zakonczPolaczenie();
    }
}

void Klient::rozpocznijPolaczenie()
{
    QString ip=ipEdit->text();
    int port=portSpin->value();
    tcpSocket->abort();
    blockSize = 0;
    tcpSocket->connectToHost(ip, port);
}

void Klient::polaczonoZSerwerem()
{
    QString a;
    a.setNum(tcpSocket->peerPort());
    infText->append(czasEdit->time().toString("HH:mm:ss")+" - Poczono z serwerem o adresie: "+tcpSocket->peerAddress().toString()+"; Port:"+a);
    a.setNum(tcpSocket->localPort());
    this->setWindowTitle("Klient: "+tcpSocket->localAddress().toString()+"; Port:"+a);
    rozlaczButton->setEnabled(true);
    polaczButton->setEnabled(false);
    ipEdit->setEnabled(false);
    portSpin->setEnabled(false);
    Idk=0;
    emit wyslijCzas();
}

void Klient::zakonczPolaczenie()
{
    tcpSocket->close();
}

void Klient::zakonczonoPolaczenie()
{
    infText->append(czasEdit->time().toString("HH:mm:ss")+" - Zakoczono poczenie z serwerem");
    this->setWindowTitle("Klient - Zakoczono poczenie");
    rozlaczButton->setEnabled(false);
    polaczButton->setEnabled(true);
    ipEdit->setEnabled(true);
    portSpin->setEnabled(true);
}

void Klient::resetujCzas()
{
    czasEdit->setTime(QTime::currentTime());
}

void Klient::uplywCzasu()
{
    //czas + 1s
        QTime time=czasEdit->time();
        time=time.addSecs(1);
        czasEdit->setTime(time);
}
void Klient::wyswietlBlad(QAbstractSocket::SocketError socketError)
{
    switch (socketError)
    {
        case QAbstractSocket::RemoteHostClosedError:
            break;

        case QAbstractSocket::HostNotFoundError:
            QMessageBox::information(this, tr("Fortune Client"),
                                                                                 tr("The host was not found. Please check the "
                                                                                         "host name and port settings."));
             break;

        case QAbstractSocket::ConnectionRefusedError:
            QMessageBox::information(this, tr("Fortune Client"),
                                                                                 tr("The connection was refused by the peer. "
                                                                                         "Make sure the fortune server is running, "
                                                                                         "and check that the host name and port "
                                                                                         "settings are correct."));
                break;

        default:
            QMessageBox::information(this, tr("Fortune Client"),
                                                                                 tr("The following error occurred: %1.")
                                                                                 .arg(tcpSocket->errorString()));
    }
}

void Klient::koniec()
{
    tcpSocket->close();
    close();
}
void Klient::czysc()
{
    infText->clear();
}
