#include "serwer.h"

#include <QtNetwork>
#include <QtGui>

Serwer::Serwer(QWidget *parent) : QWidget(parent)
{
    setWindowTitle("Aktywny Serwer Synchronizacji");
    tcpServer = new QTcpServer(this);
    connect(tcpServer, SIGNAL(newConnection()), this, SLOT(dodajKlienta()));
    clientsList = new QList<QTcpSocket*>();
    blockSizeList = new QList<quint16>();
    Frame=new QFrame();
    Frame->setFrameShape(QFrame::VLine);
    infText = new QTextBrowser();
    infText->setReadOnly(true);
    infText->setFocusPolicy(Qt::NoFocus);
    infText->setMinimumWidth(430);
    infText->setMinimumHeight(300);
    infText2 = new QTextBrowser();
    infText2->setReadOnly(true);
    infText2->setFocusPolicy(Qt::NoFocus);
    infText2->setMinimumWidth(400);
    portSpin = new QSpinBox();
    portSpin->setRange(1,65535);
    portSpin->setValue(4466);
    synchSpin = new QSpinBox();
    synchSpin->setRange(10,500);
    connect(synchSpin,SIGNAL(valueChanged(int)),this,SLOT(okresSynch(int)));
    synchSpin->setValue(20);
    odrzSpin = new QSpinBox();
    odrzSpin->setRange(60,10800);
    odrzSpin->setValue(1200);
    odrzSpin->setSingleStep(60);
    odrzLabel= new QLabel("Czas odrzucenia:");
    portLabel = new QLabel("Podaj Port:");
    ipLabel[0] = new QLabel("Ip Serwera:");
    ipLabel[1] = new QLabel();
    timeLabel[0] = new QLabel("Czas serwera:");
    timeLabel[1] = new QLabel();
    synchLabel[0] = new QLabel("Okres synch.[s]:");
    synchLabel[1] = new QLabel("Nast. synch.:");
    synchLabel[2] = new QLabel();
    rozpocznijButton = new QPushButton("Rozpocznij\nDziaanie\nSerwera");
    connect(rozpocznijButton, SIGNAL(clicked()), this, SLOT(rozpocznij()));
    rozpocznijButton->setMaximumWidth(90);
    zatrzymajButton = new QPushButton("Zatrzymaj\nSerwer");
    zatrzymajButton->setEnabled(false);
    connect(zatrzymajButton, SIGNAL(clicked()), this, SLOT(zatrzymaj()));
    zatrzymajButton->setMaximumWidth(90);
    synchButton = new QPushButton("Uruchom\nSynchronizacj");
    synchButton->setEnabled(false);
    connect(synchButton, SIGNAL(clicked()), this, SLOT(synchB()));
    synchA=0;
    synchTerazButton = new QPushButton("Synchronizuj Teraz");
    synchTerazButton->setEnabled(false);
    connect(synchTerazButton, SIGNAL(clicked()), this, SLOT(wyslijZadanie()));
    czyscButton = new QPushButton("Wyczy\nOkna");
    connect(czyscButton, SIGNAL(clicked()), this, SLOT(czysc()));
    czyscButton->setMaximumWidth(90);
    zamknijButton = new QPushButton("Zakocz\nDziaanie\nProgramu");
    connect(zamknijButton, SIGNAL(clicked()), this, SLOT(koniec()));
    zamknijButton->setMaximumWidth(90);

    mainLayout = new QGridLayout(this);
    mainLayout->addWidget(infText,0,0,7,3,Qt::AlignCenter);
    mainLayout->addWidget(infText2,7,2,3,7,Qt::AlignCenter);
    mainLayout->addWidget(czyscButton,6,5,1,1,Qt::AlignRight);
    mainLayout->addWidget(rozpocznijButton,0,5,1,1);
    mainLayout->addWidget(zatrzymajButton,1,5,1,1);
    mainLayout->addWidget(zamknijButton,2,5,1,1);
    mainLayout->addWidget(Frame,0,6,7,1);
    mainLayout->addWidget(ipLabel[0],0,7,1,1,Qt::AlignRight);
    mainLayout->addWidget(ipLabel[1],0,8,1,1,Qt::AlignLeft);
    mainLayout->addWidget(portLabel,1,7,1,1,Qt::AlignRight);
    mainLayout->addWidget(portSpin,1,8,1,1,Qt::AlignLeft);
    mainLayout->addWidget(timeLabel[0],3,7,1,1,Qt::AlignRight);
    mainLayout->addWidget(timeLabel[1],3,8,1,1,Qt::AlignLeft);
    mainLayout->addWidget(synchLabel[0],4,7,1,1,Qt::AlignRight);
    mainLayout->addWidget(synchSpin,4,8,1,1,Qt::AlignLeft);
    mainLayout->addWidget(synchLabel[1],5,7,1,1,Qt::AlignRight);
    mainLayout->addWidget(synchLabel[2],5,8,1,1,Qt::AlignLeft);
    mainLayout->addWidget(synchTerazButton,6,7,1,2,Qt::AlignCenter);
    mainLayout->addWidget(synchButton,7,1,1,1,Qt::AlignCenter);
    mainLayout->addWidget(odrzSpin,8,1,1,1,Qt::AlignLeft);
    mainLayout->addWidget(odrzLabel,8,0,1,1,Qt::AlignRight);
    ipLabel[1]->hide();

//time + 100ms
    time=QTime::currentTime();
    uplywTimer=new QTimer(this);
    uplywTimer->setSingleShot(false);
    connect(uplywTimer,SIGNAL(timeout()),this,SLOT(uplywCzasu()));
    uplywTimer->start(100);
    infText->append(time.toString("HH:mm:ss") +" - Aktywny serwer synchronizacyjny metod algorytmu z Berkeley.");
    pol=0;
    Ids=5;
}

Serwer::~Serwer()
{
    delete clientsList;
    delete blockSizeList;
}

void Serwer::uplywCzasu()
{
        time=time.addMSecs(100);//.addSecs(1);
        wys=wys+1;
        timeLabel[1]->setText(time.toString("HH:mm:ss"));
        if (time>=synchTime)
            if (pol==1&&synchA==1)
                emit wyslijZadanie();
}
void Serwer::okresSynch(int s)
{
    synchTime=time.addSecs(s);
    if(synchA==1)
        synchLabel[2]->setText(synchTime.toString("HH:mm:ss"));
}
void Serwer::rozpocznij()
{
    if (!tcpServer->listen(QHostAddress::Any, portSpin->value())){
        QMessageBox::critical(this, "Bd!", "Serwer nie moe zosta uruchomionym");
        return;
    }
    else{
        QString ipAddress;
        QList<QHostAddress> ipAddressesList = QNetworkInterface::allAddresses();

        for (int i = 0; i < ipAddressesList.size(); ++i){
            if (ipAddressesList.at(i) != QHostAddress::LocalHost && ipAddressesList.at(i).toIPv4Address()){
                ipAddress = ipAddressesList.at(i).toString();
                break;
            }
        }

        if (ipAddress.isEmpty()){
            ipAddress = QHostAddress(QHostAddress::LocalHost).toString();
        }
        ipLabel[1]->show();
        ipLabel[1]->setText(ipAddress);

        QString a;
        a.setNum(tcpServer->serverPort());
        infText->append(time.toString("HH:mm:ss") + " - Uruchomiono serwer pod adresem: "+ipAddress+"; Port:"+a);
        rozpocznijButton->setEnabled(false);
        zatrzymajButton->setEnabled(true);
        synchButton->setEnabled(true);
        portSpin->setEnabled(false);
        pol=1;
    }
    emit okresSynch(synchSpin->value());
}

void Serwer::zatrzymaj()
{
    pol=0;
    Ids=7;
    emit wyslijZadanie();
    if(synchA==1)
        emit synchB();
    infText->append(time.toString("HH:mm:ss") +" - Zamknito serwer");
    rozpocznijButton->setEnabled(true);
    zatrzymajButton->setEnabled(false);
    synchButton->setEnabled(false);
    portSpin->setEnabled(true);
    ipLabel[1]->hide();
    tcpServer->close();
}

void Serwer::koniec()
{
    tcpServer->close();
    close();
}

void Serwer::dodajKlienta()
{
    QTcpSocket *client = tcpServer->nextPendingConnection();
    clientsList->push_back(client);
    blockSizeList->push_back(0);
    QString a;
    a.setNum(client->peerPort());
    infText->append(time.toString("HH:mm:ss") +" - Rozpoczto poczenie z klientem o adresie: "+client->peerAddress().toString()+"; Port:"+a);
    connect(client, SIGNAL(disconnected()), this, SLOT(usunKlienta()));
    connect(client, SIGNAL(disconnected()), client, SLOT(deleteLater()));
    connect(client, SIGNAL(readyRead()), this, SLOT(odbierz()));
}

void Serwer::usunKlienta()
{
    QTcpSocket *client = (QTcpSocket*) sender();
    if(pol==1){
        QString a;
        a.setNum(client->peerPort());
        infText->append(time.toString("HH:mm:ss") +" - Zakoczono poczenie z klientem o adresie: "+client->peerAddress().toString()+"; Port:"+a);
    }
    int index = clientsList->indexOf(client);
    clientsList->removeAt(index);
    blockSizeList->removeAt(index);
}

void Serwer::wyslijZadanie()
{
    emit okresSynch(synchSpin->value());
    wys=0;
    if (Ids==5)
        srTime=time;
    QByteArray data;
    QDataStream out(&data, QIODevice::WriteOnly);
    out.setVersion(QDataStream::Qt_4_6);
    out << (quint16) 0;
    out << Ids;
    out << srTime;
    out.device()->seek(0);
    out << (quint16) (data.size() - sizeof(quint16));
    zliczSynch[0]=0;
    for (int i=0; i < clientsList->size(); ++i){
        clientsList->at(i)->write(data);
        zliczSynch[0]++;
    }
    QString a;
    a.setNum(zliczSynch[0]);
    if (Ids==5)
        infText->append(time.toString("HH:mm:ss")+" - Nadano danie wysania godziny do "+a+" klientw");
    else if (Ids==6){
        infText->append(time.toString("HH:mm:ss")+" - Wysano godzin synchronizacji "+srTime.toString("HH:mm:ss")+" do "+a+" klientw");
        Ids=5;
    }
    else if (Ids==7)
        Ids=5;
    zliczSynch[1]=0;
    //7-zatrzymanie serwera
}

void Serwer::odbierz()
{
    QTcpSocket *client = (QTcpSocket*) sender();
    int index = clientsList->indexOf(client);
    QDataStream in(client);
    in.setVersion(QDataStream::Qt_4_6);
    if (blockSizeList->at(index) == 0){
        if (client->bytesAvailable() < (int)sizeof(quint16)){
            return;
        }
        quint16 sizeOfBlock;
        in >> sizeOfBlock;
        (*blockSizeList)[index] = sizeOfBlock;
    }
    if (client->bytesAvailable() < blockSizeList->at(index)){
        return;
    }//*/
    int id;
    in >> id;
    in >> time2;
    zliczSynch[1]++;
    if (id!=0){
        if (zliczSynch[1]==1)
            wys=0;
        //if (id==1)
        roznicaSynch[zliczSynch[1]]=time.secsTo(time2);//.msecsTo(time2);
        warSynch[zliczSynch[1]]=1;
        QString a,a1;
        a.setNum(zliczSynch[1]);
        a1.setNum(roznicaSynch[zliczSynch[1]]);
        infText->append(time.toString("HH:mm:ss") +" - Odebrano godzin od klienta "+a+" - "+time2.toString()+" rnica:"+a1+"s");
        if (zliczSynch[1]==zliczSynch[0]||wys>10){
            if (wys>10)
                infText->append("----Nie odebrano wszystkich odpowiedzi----");
            else{
                infText->append("----Odebrano wszystkie odpowiedzi----");
                infText2->append("----Rozpoczynam proces uredniania----");
            }
            Ids=6;
            roznicaSynch[0]=0;
            for (int i=1;i<=zliczSynch[1];i++)
                if (roznicaSynch[i]>odrzSpin->value() || roznicaSynch[i]<-odrzSpin->value()){//if (roznicaSynch[0]-roznicaSynch[i]>60*60||roznicaSynch[0]-roznicaSynch[i]<-60*60){
                    warSynch[i]=0;
                    a.setNum(i);
                    infText2->append("------Odrzucono czas klienta "+a+"------");//+" - "+time2.toString()+" rnica:"+a1);
                }
            for (int i=1;i<=zliczSynch[1];i++)
                if (warSynch[i]==1)
                    roznicaSynch[0]=roznicaSynch[0]+roznicaSynch[i];
            roznicaSynch[0]=roznicaSynch[0]/(zliczSynch[1]+1);
            srTime=time.addSecs(roznicaSynch[0]);//.addMSecs(roznicaSynch[0]);
            a.setNum(roznicaSynch[0]);
            infText2->append(time.toString("HH:mm:ss") +" - rednia:"+a+"  czas:"+srTime.toString());
            emit wyslijZadanie();
        }
    }
}
void Serwer::synchB()
{
    if(synchA==0){
        infText2->append(time.toString("HH:mm:ss")+" - Uruchomiono Synchronizacj");
        synchButton->setText("Zatrzymaj\nSynchronizacj");
        synchTerazButton->setEnabled(true);
        synchA=1;
        emit okresSynch(synchSpin->value());
    }else{
        infText2->append(time.toString("HH:mm:ss")+" - Zatrzymano Synchronizacj");
        synchButton->setText("Uruchom\nSynchronizacj");
        synchTerazButton->setEnabled(false);
        synchA=0;
        synchLabel[2]->clear();
    }
}
void Serwer::czysc()
{
    infText->clear();
    infText2->clear();
}
